/*
 * 
 *Brett Oliver's version http://www.brettoliver.org.uk/Word_Clock_3D/Word_Clock_3D.htm
 *adapted from the original https://github.com/e5h/Word-Clock
 *see also https://www.instructables.com/id/Minimalist-3D-Printed-RGB-Word-Clock/
v01 UNO added indicator for mins 1,2,3,4
v02 & 03 esp8266 not working
v04 UNO adding word co=ord for Lyra clock
v05 corrected 2 hours displayed after 30mins added am pm, PIR,Brightness & PIR (needs timer)
v08 added display test to start. PIR timer added including PIRtimeout to change PIR on time in seconds
v09 new
v10 LED pin 6 to pin 11, added man /-ve 30sec sync pin 7
v11 added PIR outputs to control other clocks
v12 added LDR brightness control
v13 Display Name in rainbow 24/7
v14 Change 5 min range from eg o clock to 5 past to 58 to 02 past
v15 adjusted code for am/pm as above
v16 move am pm to bottom right 
v17 add summer/winter time buttons amd long press for word clock display test
to do not working change minute marks to LED colour on am pm indicators red 2 mins before, yel 1min, green on time, blue +1 and Pur+2
*/
#include <Adafruit_NeoPixel.h>
#include <Wire.h>
#include <EEPROM.h>
#include "RTClib.h"

//Preliminary definitions.
#define PIN 11
#define LENGTH 100
#define BUTTON_DELAY 50
#define HOLD_DELAY 1000
#define RAINBOW_DELAY 25  //150
RTC_DS3231 rtc;

//Initialize the LED grid.
Adafruit_NeoPixel grid = Adafruit_NeoPixel(LENGTH, PIN, NEO_GRB + NEO_KHZ800);


const byte secPossyncPin    =  3;// +ve pulse sync
int secsync                 =  0;
const byte manSyncPin       =  7; // Man sync
const byte PIRPin        = 12;// PIR sensor input pin
int PIROn                = 0;
int Brightness           =  100;//Brightness value
const byte brightnessPin    =  A2;//Brightness Pin
int BrightnessMeasure    = 0; //Analog brightness leval
 int LDRStop             = 0;// stop LDR measuring more than once
long PIRtimer             = 0; //used for checking PIR timings
int PIRtimeout            = 600; //PIR time on after trigger in seconds
int PIROut1               = 14; //PIR output
int PIROut2               = 15; //PIR output
//int sum_btn               = 5; // sum advance
//int win_btn               = 6; //Win retard

//Color indices
byte top_color;
byte bottom_color;
bool colors_saved = false;

void setup() {
  Serial.begin(9600);
  Wire.begin();
  grid.begin();
  grid.show();
  //rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));//set time from PC -don't use
 // rtc.adjust(DateTime(2021, 16, 12, 6, 22, 0)); //If you set the time with this re-program again with this disabled or time won't set on re-boot.

  // reads the stored color values from EEPROM.
  top_color = EEPROM.read(0);
  bottom_color = EEPROM.read(1);

  pinMode(8, INPUT);  //down button
  pinMode(9, INPUT); //up button
  pinMode(5, INPUT_PULLUP);  //summertime button
  pinMode(6, INPUT_PULLUP); //wintertime button
  pinMode(secPossyncPin, INPUT);
  pinMode(PIRPin, INPUT);
  pinMode(brightnessPin, INPUT);
  pinMode(manSyncPin, INPUT_PULLUP);
  pinMode(PIROut1, OUTPUT);
  pinMode(PIROut2, OUTPUT);
              
  
 
 //Tests each word, using a color "c" and a time delay of "t" ms between each.
  //test_words(top_color,500);
 // snake(bottom_color, 100);
 //number bounce color,number of numbers, speed
 //animate_numbers(top_color, 6, 100);
 // steps through number color,number to count to, time
// test_numbers(top_color, 10, 1000);

bottom_color = 5; //start bottom colour as green
top_color = 10; //start topcolour as purple 
}

void loop() {

   //PIR
/*
 if (digitalRead(PIRPin) == HIGH && PIROn == 1 && PIRtimer >(rtc.now().unixtime()) )
 {
   PIRtimer = (PIRtimer - (rtc.now().unixtime())) + 300;
    Serial.print("PIR Timer PIRon 1 ");
   Serial.println(PIRtimer);
 }
*/
if (digitalRead(PIRPin) == LOW && PIROn == 1 && PIRtimer <(rtc.now().unixtime()) )//when PIRtimer is less than the time now & the PIR is low the LEDs go off
{
 // Serial.println("PIR Off ");
   grid.setBrightness(0);
   digitalWrite(PIROut1,LOW);
   digitalWrite(PIROut2,LOW);
  // grid.show();
 // if(PIRtimer + 15 > (rtc.now().unixtime()))// add 15 second delay before enabling PIR again when turned off to stop false triggers
 // {
   PIROn = 0; // allows PIR to triger once
 // }
}

if (digitalRead(PIRPin) == HIGH && PIROn == 0 )
{
 //Serial.print("Unix Time ");
 //  Serial.println((rtc.now().unixtime()));
 PIRtimer = (rtc.now().unixtime()+ PIRtimeout);// PIRtimer = Unix time now + PIRtimeout value in seconds.
 
//Serial.print("PIR Timer ");
 //  Serial.println(PIRtimer);
 digitalWrite(PIROut1,HIGH);
   digitalWrite(PIROut2,HIGH);
 grid.setBrightness(Brightness);
 //grid.show();
 PIROn = 1; //allows PIR to triger once
 
}


 //Brightness LDR controlled 
if((rtc.now().second() == 1 || rtc.now().second() == 11 || rtc.now().second() == 21 || rtc.now().second() == 31 || rtc.now().second() == 41 || rtc.now().second() == 51) && LDRStop == 0 && PIROn == 1)
{
  BrightnessMeasure = analogRead(brightnessPin);
  LDRStop = 1;
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     //the following 3 lines ae used for setting up the LDR. Comment out after setup completed
   
  //  Serial.print ("brightnessPin Value ");
  //   Serial.println (BrightnessMeasure);
  //   Serial.print ("Display Brightness ");
  //   Serial.println (Brightness );
    
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


  
//1

if (BrightnessMeasure >= 0 && BrightnessMeasure < 64)
 {
   Brightness = 15; 
 // LDRStop = 1;
   
 }

//2
 else if (BrightnessMeasure >= 64 && BrightnessMeasure < 128)
 {
   Brightness = 30; 
 // LDRStop = 1;
   
 }

 //3
 else if (BrightnessMeasure >= 128 && BrightnessMeasure < 192)
 {
   Brightness = 45; 
LDRStop = 1;
 }

 //4
 else if (BrightnessMeasure >= 192 && BrightnessMeasure < 256)
 {
   Brightness = 60;
  
 // LDRStop = 1;
 }

 //5
 else if (BrightnessMeasure >= 256 && BrightnessMeasure < 320 )
 {
   Brightness = 75;
 // LDRStop = 1;
 
 }

 //6
 else if (BrightnessMeasure >= 320 && BrightnessMeasure < 384)
 {
   Brightness = 90; 
 // LDRStop = 1;   
 }

 //7
 else if (BrightnessMeasure >= 384 && BrightnessMeasure < 448)
 {
   Brightness = 105; 
 // LDRStop = 1;
 
 }

 
 //8
 else if (BrightnessMeasure >= 448 && BrightnessMeasure < 512)
 {
   Brightness = 120; 
  // LDRStop = 1;
 
 }

 //9
 else if (BrightnessMeasure >= 512 && BrightnessMeasure < 576)
 {
   Brightness = 135; 
  // LDRStop = 1;
 }

 //10
 else if (BrightnessMeasure >= 576 && BrightnessMeasure < 640)
 {
   Brightness = 150; 
  // LDRStop = 1;
 }

 //11
 else if (BrightnessMeasure >= 640 && BrightnessMeasure < 704)
 {
   Brightness = 165;
  // LDRStop = 1;
 }

 //12
 else if (BrightnessMeasure >= 704 && BrightnessMeasure < 768)
 {
   Brightness = 180; 
  // LDRStop = 1;
 }

 //13
 else if (BrightnessMeasure >= 768 && BrightnessMeasure < 832)
 {
   Brightness = 195;
  // LDRStop = 1;
 }

 //14
 else if (BrightnessMeasure >= 832 && BrightnessMeasure < 896)
 {
   Brightness = 210; 
  // LDRStop = 1;
 }

 //15
 else if (BrightnessMeasure >= 896 && BrightnessMeasure < 960)
 {
   Brightness = 225; 
   
 }

 //16
 else if (BrightnessMeasure >= 960 && BrightnessMeasure < 1024)
 {
   Brightness = 240; 
  // LDRStop = 1;
 }
 
 grid.setBrightness(Brightness);
 
}


 if(rtc.now().second() == 2 || rtc.now().second() == 12 || rtc.now().second() == 22 || rtc.now().second() == 32 || rtc.now().second() == 42 || rtc.now().second() == 52 )
{ 
  LDRStop = 0;
}



 /*
 //Brightness  Button controlled
 if (digitalRead(brightnessPin) == LOW )
{
   Brightness += 1;
   grid.setBrightness(Brightness);   
  
   
   
   if (Brightness > 240)
   {
    Brightness = 1;
    grid.setBrightness(Brightness);
   }
  // Serial.print("Brightness ");
  // Serial.println(Brightness);
  //grid.show();
 //secondcheck = masterTime.Second();
}

*/
 
  
  
  
  
  
  
  
  //Synch seconds to 30 from master clock
if (digitalRead(secPossyncPin) == HIGH && secsync == 1)
{

    rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), rtc.now().hour(), rtc.now().minute(), 30));
   //resetSeconds30();
   // Serial.print("Seconds ");
  // Serial.println(rtc.now().second());
   
   secsync = 0;
}

 if (rtc.now().second() == 10  )
     {
      secsync = 1;
     // Serial.println("10 Seconds ");
  
     }
  

// Man seconds sync to 30 seconds
 //Synch seconds to 30 from master clock
if (digitalRead(manSyncPin) == LOW && secsync == 1)
{

    rtc.adjust(DateTime(rtc.now().year(),rtc.now().month(), rtc.now().day(), rtc.now().hour(), rtc.now().minute(), 30));
   //resetSeconds30();
   // Serial.print("Seconds ");
  // Serial.println(rtc.now().second());
   
   secsync = 0;
}

 


  
  
  static byte state = 0; // Keeps track of the current clock state.

  wipe();
  switch(state){
    case 0: // Regular clock display
      display_time(colors(top_color), colors(bottom_color));
      display_bday();
      check_buttons(&state);
      break;
    case 1: // Second menu state
      S(grid.Color(255, 255, 255));
      if(colors_saved == true){
        little_C(grid.Color(0, 255, 0));
      }
      else{
        little_C(grid.Color(255, 128, 0));
      }
      check_buttons(&state);
      break;
    case 2: // Minute menu state
      M(grid.Color(255, 255, 255));
      if(colors_saved == true){
        little_C(grid.Color(0, 255, 0));
      }
      else{
        little_C(grid.Color(255, 128, 0));
      }
      check_buttons(&state);
      break;
    case 3: // Hour menu state
      H(grid.Color(255, 255, 255));
      if(colors_saved == true){
        little_C(grid.Color(0, 255, 0));
      }
      else{
        little_C(grid.Color(255, 128, 0));
      }
      check_buttons(&state);
      break;
    case 4: // Numerical time display
      display_hm(colors(top_color), colors(bottom_color));
      check_buttons(&state);
      break;
    case 11: // Clock edit - seconds
      display_ms(grid.Color(255, 255, 255), flash_color(grid.Color(255, 255, 255), grid.Color(255, 0, 0), 100));
      check_buttons(&state);
      break;
    case 12: // Clock edit - minutes
      display_ms(flash_color(grid.Color(255, 255, 255), grid.Color(255, 0, 0), 100), grid.Color(255, 255, 255));
      check_buttons(&state);
      break;
    case 13: // Clock edit - hours
      display_hm(flash_color(grid.Color(255, 255, 255), grid.Color(255, 0, 0), 100), grid.Color(255, 255, 255));
      check_buttons(&state);
      break;
  }
  grid.show();
}
